%%
%% External events support for BP-Erl
%%
-module(bp_ext).
-include("bp.hrl").
-include("bp_ext.hrl").
-export([start_idler/0, start_queue/0, push/1, start_link_dispatcher/1]).

idler_loop() ->
	case bp:bSync(#rwb{request=[?IDLE], wait=[?QUIT]}) of
		?QUIT -> ok;
		?IDLE -> idler_loop()
	end.

start_idler() ->
	bp:add(fun idler_loop/0, ?MAX_PRIO-1).

dispatch_loop() ->
	bp:bSync(#rwb{wait=[?IDLE]}),
	receive 
		shutdown -> ok;
		E ->
			case bp:bSync(#rwb{request=[E], wait=?ALL}) of
				?QUIT -> ok;
				_ -> dispatch_loop()
			end 
	end.

start_queue() ->
	Pid = bp:add(fun dispatch_loop/0, ?MAX_PRIO-2),	
	register(bqueue, Pid).

push(E) ->
	case whereis(bqueue) of
		Pid when is_pid(Pid) -> Pid ! E;
		undefined -> {noqueue, E}
	end.

start_link_dispatcher(Make) ->
	Disp = fun() ->
				   WxRef = Make(),
				   wxLink:link(WxRef),
				   dispatch_loop()
		   end,
	bp:add(Disp, ?MAX_PRIO-2).
	
